std::__detail Namespace Reference
Iterators

## Classes

struct | _BracketMatcher
class | _Compiler
class | _Executor
struct | _List_node_base
struct | _List_node_header
struct | _Quoted_string
class | _Scanner
class | _StateSeq

## Typedefs

using | __bare_timed_wait
using | __bare_wait
using | __enters_timed_wait
using | __enters_wait
template<typename _Tp>
using | __integer_from_chars_result_type
template<typename _Tp>
using | __integer_to_chars_result_type
using | __platform_wait_t
template<typename _Tp>
using | __unsigned_least_t
using | __wait_clock_t
template<typename _CharT>
using | _Matcher
typedef long | _StateIdT

## Enumerations

enum | _Opcode : int { _S_opcode_unknown , _S_opcode_alternative , _S_opcode_repeat , _S_opcode_backref , _S_opcode_line_begin_assertion , _S_opcode_line_end_assertion , _S_opcode_word_boundary , _S_opcode_subexpr_lookahead , _S_opcode_subexpr_begin , _S_opcode_subexpr_end , _S_opcode_dummy , _S_opcode_match , _S_opcode_accept }
enum class | _RegexExecutorPolicy : int { _S_auto , _S_alternate }

## Functions

template<typename _Res, typename _Tp>
constexpr _Res | __abs_r (_Tp __val)
template<typename>
void | __abs_r (bool)=delete
template<typename _Tp>
bool | __atomic_compare (const _Tp &__a, const _Tp &__b)
template<typename _Pred, typename _Spin = __default_spin_policy>
bool | __atomic_spin (_Pred &__pred, _Spin __spin=_Spin{ }) noexcept
template<typename _Clock, typename _Dur>
bool | __cond_wait_until (__condvar &__cv, mutex &__mx, const chrono::time_point< _Clock, _Dur > &__atime)
template<typename _Clock, typename _Dur>
bool | __cond_wait_until_impl (__condvar &__cv, mutex &__mx, const chrono::time_point< _Clock, _Dur > &__atime)
template<typename _Container, typename _Predicate>
_Container::size_type | __erase_nodes_if (_Container &__cont, _Predicate __pred)
template<typename _ValT, typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & | __extract_params (basic_istream< _CharT, _Traits > &__is, vector< _ValT > &__vals, size_t __n)
template<typename _Tp>
bool | __from_chars_alnum (const char *&__first, const char *__last, _Tp &__val, int __base)
constexpr char | __from_chars_alpha_to_num (char __c)
template<typename _Tp>
bool | __from_chars_binary (const char *&__first, const char *__last, _Tp &__val)
template<typename _Tp>
bool | __from_chars_digit (const char *&__first, const char *__last, _Tp &__val, int __base)
template<typename _Tp>
constexpr _Tp | __gcd (_Tp __m, _Tp __n)
template<typename _Tp>
constexpr bool | __p1_representable_as_double (_Tp __x) noexcept
template<typename _Tp>
bool | __raise_and_add (_Tp &__val, int __base, unsigned char __c)
template<typename _BiIter, typename _Alloc, typename _CharT, typename _TraitsT, _RegexExecutorPolicy __policy, bool __match_mode>
bool | __regex_algo_impl (_BiIter __s, _BiIter __e, match_results< _BiIter, _Alloc > &__m, const basic_regex< _CharT, _TraitsT > &__re, regex_constants::match_flag_type __flags)
template<typename _Tp>
constexpr bool | __representable_as_double (_Tp __x) noexcept
template<typename _Tp>
void | __return_temporary_buffer (_Tp *__p, size_t __len)
void | __thread_relax () noexcept
void | __thread_yield () noexcept
template<typename _Tp>
to_chars_result | __to_chars (char *__first, char *__last, _Tp __val, int __base) noexcept
template<typename _Tp>
__integer_to_chars_result_type< _Tp > | __to_chars_10 (char *__first, char *__last, _Tp __val) noexcept
template<typename _Tp>
void | __to_chars_10_impl (char *__first, unsigned __len, _Tp __val) noexcept
template<typename _Tp>
__integer_to_chars_result_type< _Tp > | __to_chars_16 (char *__first, char *__last, _Tp __val) noexcept
template<typename _Tp>
__integer_to_chars_result_type< _Tp > | __to_chars_2 (char *__first, char *__last, _Tp __val) noexcept
template<typename _Tp>
__integer_to_chars_result_type< _Tp > | __to_chars_8 (char *__first, char *__last, _Tp __val) noexcept
template<typename _Tp>
constexpr unsigned | __to_chars_len (_Tp __value, int __base) noexcept
template<typename _Tp>
constexpr unsigned | __to_chars_len_2 (_Tp __value) noexcept
template<typename _Dur>
__wait_clock_t::time_point | __to_wait_clock (const chrono::time_point< __wait_clock_t, _Dur > &__atime) noexcept
template<typename _Clock, typename _Dur>
__wait_clock_t::time_point | __to_wait_clock (const chrono::time_point< _Clock, _Dur > &__atime) noexcept
template<typename _Tp>
constexpr bool | _Power_of_2 (_Tp __x)
template<typename _CharT, typename _Traits, typename _String>
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &__os, const _Quoted_string< _String, _CharT > &__str)
template<typename _CharT, typename _Traits>
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &__os, const _Quoted_string< const _CharT *, _CharT > &__str)
template<typename _CharT, typename _Traits, typename _Alloc>
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &__is, const _Quoted_string< basic_string< _CharT, _Traits, _Alloc > &, _CharT > &__str)

## Variables

constexpr auto | __atomic_spin_count
constexpr auto | __atomic_spin_count_relax
static constexpr size_t | __platform_wait_alignment
static const _StateIdT | _S_invalid_state_id

## Detailed Description

Implementation details not part of the namespace std interface.

## Typedef Documentation

## __bare_timed_wait

using std::__detail::__bare_timed_wait

Definition at line 382 of file atomic_timed_wait.h.

## __bare_wait

using std::__detail::__bare_wait

Definition at line 414 of file atomic_wait.h.

## __enters_timed_wait

using std::__detail::__enters_timed_wait

Definition at line 381 of file atomic_timed_wait.h.

## __enters_wait

using std::__detail::__enters_wait

Definition at line 413 of file atomic_wait.h.

## __integer_from_chars_result_type

template<typename _Tp>

using std::__detail::__integer_from_chars_result_type

Definition at line 582 of file charconv.

## __integer_to_chars_result_type

template<typename _Tp>

using std::__detail::__integer_to_chars_result_type

Definition at line 81 of file charconv.

## __platform_wait_t

using std::__detail::__platform_wait_t

Definition at line 67 of file atomic_wait.h.

## __unsigned_least_t

template<typename _Tp>

using std::__detail::__unsigned_least_t

Definition at line 103 of file charconv.

## __wait_clock_t

using std::__detail::__wait_clock_t

Definition at line 54 of file atomic_timed_wait.h.

## Enumeration Type Documentation

## _RegexExecutorPolicy

enum class std::__detail::_RegexExecutorPolicy : int

strong

Definition at line 45 of file regex.h.

## Function Documentation

## __abs_r()

template<typename _Res, typename _Tp>

_Res std::__detail::__abs_r | ( | _Tp | __val | ) |

constexpr

Definition at line 101 of file numeric.

## __atomic_compare()

template<typename _Tp>

bool std::__detail::__atomic_compare | ( | const _Tp & | __a,
|  | const _Tp & | __b )

Definition at line 182 of file atomic_wait.h.

## __atomic_spin()

template<typename _Pred, typename _Spin = __default_spin_policy>

bool std::__detail::__atomic_spin | ( | _Pred & | __pred,
|  | _Spin | __spin = _Spin{ } )

noexcept

Definition at line 158 of file atomic_wait.h.

## __cond_wait_until()

template<typename _Clock, typename _Dur>

bool std::__detail::__cond_wait_until | ( | __condvar & | __cv,
|  | mutex & | __mx,
|  | const chrono::time_point< _Clock, _Dur > & | __atime )

Definition at line 174 of file atomic_timed_wait.h.

## __cond_wait_until_impl()

template<typename _Clock, typename _Dur>

bool std::__detail::__cond_wait_until_impl | ( | __condvar & | __cv,
|  | mutex & | __mx,
|  | const chrono::time_point< _Clock, _Dur > & | __atime )

Definition at line 147 of file atomic_timed_wait.h.

## __erase_nodes_if()

template<typename _Container, typename _Predicate>

_Container::size_type std::__detail::__erase_nodes_if | ( | _Container & | __cont,
|  | _Predicate | __pred )

Definition at line 51 of file erase_if.h.

## __extract_params()

template<typename _ValT, typename _CharT, typename _Traits>

basic_istream< _CharT, _Traits > & std::__detail::__extract_params | ( | basic_istream< _CharT, _Traits > & | __is,
|  | vector< _ValT > & | __vals,
|  | size_t | __n )

Definition at line 2776 of file bits/random.tcc.

## __from_chars_alnum()

template<typename _Tp>

bool std::__detail::__from_chars_alnum | ( | const char *& | __first,
|  | const char * | __last,
|  | _Tp & | __val,
|  | int | __base )

std::from_chars implementation for integers in bases 11 to 36.

Definition at line 558 of file charconv.

Referenced by std::from_chars().

## __from_chars_alpha_to_num()

char std::__detail::__from_chars_alpha_to_num | ( | char | __c | ) |

constexpr

Definition at line 469 of file charconv.

## __from_chars_binary()

template<typename _Tp>

bool std::__detail::__from_chars_binary | ( | const char *& | __first,
|  | const char * | __last,
|  | _Tp & | __val )

std::from_chars implementation for integers in base 2.

Definition at line 412 of file charconv.

Referenced by std::from_chars().

## __from_chars_digit()

template<typename _Tp>

bool std::__detail::__from_chars_digit | ( | const char *& | __first,
|  | const char * | __last,
|  | _Tp & | __val,
|  | int | __base )

std::from_chars implementation for integers in bases 3 to 10.

Definition at line 439 of file charconv.

Referenced by std::from_chars().

## __gcd()

template<typename _Tp>

_Tp std::__detail::__gcd | ( | _Tp | __m,
|  | _Tp | __n )

constexpr

Definition at line 120 of file numeric.

## __p1_representable_as_double()

template<typename _Tp>

bool std::__detail::__p1_representable_as_double | ( | _Tp | __x | ) |

constexpr noexcept

Definition at line 825 of file bits/random.tcc.

## __raise_and_add()

template<typename _Tp>

bool std::__detail::__raise_and_add | ( | _Tp & | __val,
|  | int | __base,
|  | unsigned char | __c )

Definition at line 401 of file charconv.

## __representable_as_double()

template<typename _Tp>

bool std::__detail::__representable_as_double | ( | _Tp | __x | ) |

constexpr noexcept

Definition at line 812 of file bits/random.tcc.

## __return_temporary_buffer()

template<typename _Tp>

void std::__detail::__return_temporary_buffer | ( | _Tp * | __p,
|  | size_t | __len )

inline

Definition at line 70 of file stl_tempbuf.h.

## __thread_relax()

void std::__detail::__thread_relax | ( |  | ) |

inline noexcept

Definition at line 136 of file atomic_wait.h.

## __thread_yield()

void std::__detail::__thread_yield | ( |  | ) |

inline noexcept

Definition at line 128 of file atomic_wait.h.

## __to_chars()

template<typename _Tp>

to_chars_result std::__detail::__to_chars | ( | char * | __first,
|  | char * | __last,
|  | _Tp | __val,
|  | int | __base )

noexcept

Definition at line 119 of file charconv.

## __to_chars_10()

template<typename _Tp>

__integer_to_chars_result_type< _Tp > std::__detail::__to_chars_10 | ( | char * | __first,
|  | char * | __last,
|  | _Tp | __val )

inline noexcept

Definition at line 207 of file charconv.

## __to_chars_10_impl()

template<typename _Tp>

void std::__detail::__to_chars_10_impl | ( | char * | __first,
|  | unsigned | __len,
|  | _Tp | __val )

noexcept

Definition at line 72 of file charconv.h.

## __to_chars_16()

template<typename _Tp>

__integer_to_chars_result_type< _Tp > std::__detail::__to_chars_16 | ( | char * | __first,
|  | char * | __last,
|  | _Tp | __val )

noexcept

Definition at line 160 of file charconv.

## __to_chars_2()

template<typename _Tp>

__integer_to_chars_result_type< _Tp > std::__detail::__to_chars_2 | ( | char * | __first,
|  | char * | __last,
|  | _Tp | __val )

noexcept

Definition at line 285 of file charconv.

## __to_chars_8()

template<typename _Tp>

__integer_to_chars_result_type< _Tp > std::__detail::__to_chars_8 | ( | char * | __first,
|  | char * | __last,
|  | _Tp | __val )

noexcept

Definition at line 231 of file charconv.

## __to_chars_len()

template<typename _Tp>

unsigned std::__detail::__to_chars_len | ( | _Tp | __value,
|  | int | __base = 10 )

constexpr noexcept

Definition at line 47 of file charconv.h.

## __to_chars_len_2()

template<typename _Tp>

unsigned std::__detail::__to_chars_len_2 | ( | _Tp | __value | ) |

constexpr noexcept

Definition at line 113 of file charconv.

## __to_wait_clock() [1/2]

template<typename _Dur>

__wait_clock_t::time_point std::__detail::__to_wait_clock | ( | const chrono::time_point< __wait_clock_t, _Dur > & | __atime | ) |

noexcept

Definition at line 69 of file atomic_timed_wait.h.

## __to_wait_clock() [2/2]

template<typename _Clock, typename _Dur>

__wait_clock_t::time_point std::__detail::__to_wait_clock | ( | const chrono::time_point< _Clock, _Dur > & | __atime | ) |

noexcept

Definition at line 58 of file atomic_timed_wait.h.

## _Power_of_2()

template<typename _Tp>

bool std::__detail::_Power_of_2 | ( | _Tp | __x | ) |

constexpr

Definition at line 65 of file uniform_int_dist.h.

## operator<<() [1/2]

template<typename _CharT, typename _Traits, typename _String>

std::basic_ostream< _CharT, _Traits > & std::__detail::operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const _Quoted_string< _String, _CharT > & | __str )

Inserter for quoted strings.

_GLIBCXX_RESOLVE_LIB_DEFECTS DR 2344 quoted()'s interaction with padding is unclear

Definition at line 1 of file quoted_string.h.

## operator<<() [2/2]

template<typename _CharT, typename _Traits>

std::basic_ostream< _CharT, _Traits > & std::__detail::operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const _Quoted_string< const _CharT *, _CharT > & | __str )

Inserter for quoted strings.

_GLIBCXX_RESOLVE_LIB_DEFECTS DR 2344 quoted()'s interaction with padding is unclear

Definition at line 1 of file quoted_string.h.

## operator>>()

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_istream< _CharT, _Traits > & std::__detail::operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | const _Quoted_string< basic_string< _CharT, _Traits, _Alloc > &, _CharT > & | __str )

Extractor for delimited strings. The left and right delimiters can be different.

Definition at line 139 of file quoted_string.h.

References std::basic_ios< _CharT, _Traits >::clear(), std::ios_base::flags(), std::basic_ios< _CharT, _Traits >::good(), std::ios_base::setf(), std::ios_base::skipws, and std::basic_istream< _CharT, _Traits >::unget().

## Variable Documentation

## __atomic_spin_count

auto std::__detail::__atomic_spin_count

constexpr

Definition at line 146 of file atomic_wait.h.

## __atomic_spin_count_relax

auto std::__detail::__atomic_spin_count_relax

constexpr

Definition at line 145 of file atomic_wait.h.

## __platform_wait_alignment

size_t std::__detail::__platform_wait_alignment

static constexpr

Definition at line 68 of file atomic_wait.h.